/**
 *	@file TmpFile.c
 *	@brief	e|fBNgɃe|t@C쐬.
 *	@author tenk*
 *	@note
 *		Public Domain Software
 */

#include "TmpFile.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>

// ̃t@CŁA{IȖO날킹.
#ifdef _WIN32
 #include <windows.h>
 #include <tchar.h>
 #include <io.h>
 #include <tchar.h>
 #define DISK_MAX_PATH	_MAX_PATH
 #define uint64_t		unsigned __int64
#else	// winȊOłchar̂.
 #include <stddef.h>
 #include <unistd.h>
 #define _T(x)			x
 #define TCHAR			char
 #define _tcslen(s)		strlen(s)
 #define _tcsncpy		strncpy
 #define _tsnprintf		snprintf
 #define DISK_MAX_PATH	4096
#endif


//===========================================================================
// e|Et@C.
//===========================================================================

#if defined _WIN32 || defined MSDOS
/**	ϐtmp  temp ΂̓eAȂ"."ĕԂ.
 *	@return		0:tmp,temp.  1:.
 */
int TmpFile_getTmpEnv(TCHAR tmpEnv[], size_t size)
{
	int 		 f = 1;
	const TCHAR* p = _tgetenv(_T("TMP"));
	assert(tmpEnv && size > 0);
	if (p == NULL) {
		p = _tgetenv(_T("TEMP"));
		if (p == NULL) {
			p = _T(".");
			f = 0;
		}
	}
	_tcsncpy(tmpEnv, p, size-1);
	tmpEnv[size-1] = 0;
	return f;
}
#else
/**	/tmp Ԃ.
 *	@return		1
 */
int TmpFile_getTmpEnv(TCHAR tmpEnv[], size_t size)
{
	_tcsncpy(tmpEnv, "/tmp", size-1);
	tmpEnv[size-1] = 0;
	return 1;
}
#endif



/** e|t@C쐬. handleԂ.
 */
#ifdef _WIN32
//static HANDLE TmpFile_open(TCHAR name[], size_t size, const TCHAR* prefix)
//{
//	if (TmpFile_openName(name, size, prefix)) {
//		return CreateFile(name, GENERIC_WRITE, 0, CREATE_ALWAYS,FILE_ATTRIBUTE_TEMPORARY, 0);
//	}
//}
#else
static int	  TmpFile_open(TCHAR name[], size_t size, const TCHAR* prefix)
{
	TCHAR	nm[ DISK_MAX_PATH + 2 ];
	int		hdl;
	assert(name != 0 && size > 0 && prefix != 0);
	_tsnprintf( nm, DISK_MAX_PATH, _T("/tmp/%s.XXXXXX"), prefix );
	hdl = mkstemp( nm );
	if (hdl >= 0) {
		if (_tcslen(nm) < size) {
			_tcsncpy(name, nm, size-1);
			name[size-1] = 0;
		} else { 	// t@CƕԂȂȂ玸s.
			close(hdl);
			remove(nm);
			hdl = -1;
		}
	}
	return hdl;
}
#endif



/** e|t@C쐬. nameԂAsNULL.
 *	prefix windows3oCg.
 *	ƁAe|fBNgɂ̖Õt@CłĂ̂Œ.(close)
 *	(܂莩ō폜ȂƑʖ)
 */
TCHAR* TmpFile_make(TCHAR name[], size_t size, const TCHAR* prefix)
{
  #ifdef _WIN32
	TCHAR	tmpd[ DISK_MAX_PATH + 2];
	TCHAR	nm[ DISK_MAX_PATH + 2 ];
	int		val;
	assert(name != 0 && size > 0 && prefix != 0);
	TmpFile_getTmpEnv(tmpd, DISK_MAX_PATH);
	val = GetTempFileName( tmpd, prefix, 0, nm );
	if (val > 0) {
		_tcsncpy(name, nm, size-1);
		name[size-1] = 0;
		return name;
	}
	return 0;
  #else
	int hdl = TmpFile_open(name, size, prefix);
	if (hdl >= 0) {	// nh擾łĂAwinɎ邽߁At@CcloseċA.
		close(hdl);
		return name;
	} else {
		return 0;
	}
  #endif
}



#ifdef FNAME_INCLUDED	// fname gꍇ.
/**	ϐtmp  temp e|fBNg擾. Ȃ΃Jg"./"Ԃ.
 *	@return		0:tmp,temp.  1:.
 */
int TmpFile_getTmpDir(TCHAR *dirName, size_t dirNameLen)
{
  #if defined _WIN32
	// winNT/2kGetTempPathTMP,TEMPȂƂwindowsfBNg炵̂ł߂ĎO.
	TCHAR 	nm[DISK_MAX_PATH+2];
	int 	f = TmpFile_getTmpEnv(nm, DISK_MAX_PATH);
	fname_addSep(nm, DISK_MAX_PATH);
	fname_cat(nm, DISK_MAX_PATH, _T("*.*"));
	fname_fullpath(dirName, dirNameLen, nm, "/");
	fname_getDir(dirName, dirNameLen, dirName);
  #else
	fname_cpy(dirName, dirNameLen, "/tmp");
  #endif
	return f;
}
#endif
