/**
 *	@file	disk_fileload.c
 *	@brief	fBXÑt@C[hZ[u.
 *	@author	tenk*
 *	@note
 *	-	disk_ƂĂ邪Adisk.hɂ͈ˑĂȂ.
 *	-	rIėp. (TCHAR̂Ƃ)
 *	-	Public Domain Software
 */

#include "disk_fileload.h"

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

// ̃t@CŁA{IȖO날킹.
#ifdef _WIN32
 #include <tchar.h>
 #include <io.h>
 #include <tchar.h>
 #define uint64_t	unsigned __int64
#else	// winȊOłchar̂.
 //#define _LARGEFILE64_SOURCE			// ƃRpCIvVɒ`.
 //#define _FILE_OFFSET_BITS	64		// ƃRpCIvVɒ`.
 #include <stddef.h>
 #include <unistd.h>
 #include <sys/stat.h>
 #ifndef TCHAR
  #define TCHAR		char
 #endif
 #define _T(x)		x
 #define _tfopen	fopen
#endif



/** w肵t@C̃t@CTCYԂ.
 */
size_t		disk_loadSize(const TCHAR* fname)
{
	size_t	filesize = 0;
	if (fname && fname[0]) {
	  #ifdef _WIN32
		WIN32_FIND_DATA	findData;
		HANDLE 			hdl 	= FindFirstFile(fname, &findData);
		if (hdl != INVALID_HANDLE_VALUE ) {
		  #ifdef _WIN64
			filesize = ((uint64_t)findData.nFileSizeHigh << 32) | findData.nFileSizeLow;
		  #else
			filesize = findData.nFileSizeLow;
		  #endif
			FindClose(hdl);
		}
	  #else
		struct stat		st;
		if (stat(fname, &st) == 0) {
			filesize = st.st_size;
		}
	  #endif
	}
	return filesize;
}



/** t@C[h.
 */
void*	disk_fileLoad(const TCHAR* fname, void* mem, size_t size, size_t* pReadSize)
{
	FILE *	fp;
	assert(mem != NULL && size > 0);
	fp = _tfopen(fname, _T("rb"));
	if (fp) {
		size_t rdSize = fread(mem, 1, size, fp);
		if (ferror(fp))
			mem = NULL;
		if (pReadSize)
			*pReadSize = rdSize;
		fclose(fp);
	} else {
		mem = NULL;
	}
	return mem;
}



/** t@C[h.
 */
int disk_fileSave(const TCHAR* fname, const void* mem, size_t size)
{
	FILE*	fp;
	size_t	n;
	assert(mem != NULL);
	assert(size > 0);
	if (mem == 0 || size == 0)
		return 0;

	fp = _tfopen(fname, _T("wb"));
	if (fp == NULL)
		return 0;
	n = fwrite(mem, 1, size, fp);
	if (ferror(fp))
		n = size - 1;
	fclose(fp);

	return n == size;
}



#if 1 // Ƃ肠A_~[.


/** t@Cǂݍ݃NGXg.
 */
disk_loadRq_t	disk_fileLoadRq(const TCHAR* fname, void* mem, size_t size)
{
	return disk_fileLoad(fname, mem, size, NULL);
}


/** fileLoadRqt@CǂݏI?
 *	ǂݍݒȂ 0, ǂݏI邩G[I0ȊOԂ.
 *	܂A0ȊOԂOɁANGXgǂݍ݂Ɋւ郁̊Js.
 */
int disk_fileLoadEnd(disk_loadRq_t rq)
{
	return rq != 0;
}

#endif
