/**
 *	@file	disk_fileload.h
 *	@brief	fBXÑt@C[hZ[u.
 *	@author	tenk*
 *	@note
 *	-	disk_ƂĂ邪Adisk.hɂ͈ˑĂȂ.
 *	-	rIėp. (TCHAR̂Ƃ)
 *	-	Public Domain Software
 */

#ifndef DISK_FILELOAD_H
#define DISK_FILELOAD_H

#include <stddef.h>
#if defined _WIN32
 #include <windows.h>
 #include <tchar.h>
#else
 #ifndef TCHAR
  #define TCHAR	char
 #endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

size_t			disk_loadSize(const TCHAR* fname);		///< [hpɃTCY擾.
void*			disk_fileLoad(const TCHAR* fname, void* mem, size_t size, size_t* pReadSize);	///< t@C[h.
int				disk_fileSave(const TCHAR* fname, const void* mem, size_t size);				///< t@CZ[u.


#if 1 // cd/dvd ̓Ǎp (_~[)
typedef void*	disk_loadRq_t;
disk_loadRq_t	disk_fileLoadRq(const TCHAR* fname, void* mem, size_t size);
int 			disk_fileLoadEnd(disk_loadRq_t rq);
#endif


#ifdef __cplusplus
}
#endif


#ifdef __cplusplus

/// std::vector<T>݊̃ReiɃt@Ce[h.
template<class VEC>
bool	disk_fileSave(const TCHAR* fname, const VEC& rVec) {
	const void* adr   = &rVec[0];
	size_t		bytes = rVec.size() * sizeof(rVec[0]);
	return disk_fileSave(fname, adr, bytes) != 0;
}


/// std::vector<T>݊̃ReiɃt@Ce[h.
template<class VEC>
bool	disk_fileLoad(const TCHAR* fname, VEC& rVec) {
	rVec.clear();
	size_t	file_bytes = disk_loadSize(fname);
	if (file_bytes > 0) {
		size_t	n	  = (file_bytes + sizeof(rVec[0]) - 1) / sizeof(rVec[0]);
		rVec.resize( n );
		size_t	bytes = rVec.size() * sizeof(rVec[0]);
		if (bytes > 0)
			return disk_fileLoad( fname, &rVec[0], bytes, 0 ) != 0;
	}
	return 0;
}


template<class VEC>
disk_loadRq_t	disk_fileLoadRq(const TCHAR* fname, VEC& rVec) {
	rVec.clear();
	size_t	file_bytes = disk_loadSize(fname);
	if (file_bytes > 0) {
		size_t	n	  = (file_bytes + sizeof(rVec[0]) - 1) / sizeof(rVec[0]);
		rVec.resize( n );
		size_t	bytes = rVec.size() * sizeof(rVec[0]);
		if (bytes > 0)
			return disk_fileLoadRq( fname, &rVec[0], bytes );
	}
	return 0;
}

#endif	// __cplusplus

#endif
